# $Id: Panel.py,v 1.3 2005/03/27 17:06:43 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2005/03/27 17:06:43 $"
__copyright__  = "Copyright (c) 2004-2005 Aaron Straup Cope. GNU GPL 2"

import wx

from ImageWidget.Constants import *

class ImageWidgetPanel (wx.Panel) :

    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)
        self.Image = None

        wx.EVT_PAINT(self, self.OnPaint)

    def ScaleImage(self,img,maxheight,maxwidth):

        W = img.GetWidth()
        H = img.GetHeight()

	if W < maxwidth and H < maxheight:
	   return img

        if W > H:
            NewW = maxwidth
            NewH = maxwidth * H / W
        else:
            NewH = maxheight
            NewW = maxheight * W / H

        return img.Scale(NewW,NewH)

    def Display (self, image) :
        self.Image = image
        self.Refresh(True)

    def OnPaint (self, evt) :

        if self.Image:

	   img_x  = self.Image.GetWidth()
	   img_y  = self.Image.GetHeight()

	   dc = wx.PaintDC(self)
           dc.SetBrush(wx.Brush("#000000"))
	   
	   dc.DrawRectangle(0,0,
			    img_x + (IMAGEWIDGET_DIM_BORDER * 2),
			    img_y + (IMAGEWIDGET_DIM_BORDER * 2))

           dc.DrawBitmap(self.Image.ConvertToBitmap(),
			 IMAGEWIDGET_DIM_BORDER,
			 IMAGEWIDGET_DIM_BORDER)
